//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package master;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import utils.Responser;

import master.thread.ControladorConexoes;

public class Master extends Responser {
	private int port;
	private String MD5String;
	private String originalString = "";
	private boolean finish = false;
	private StringController sc = new StringController();
	private ControladorConexoes aceitador;

	public Master(int port, String MD5String) {
		this.port = port;
		this.MD5String = MD5String;
	}

	public void runMaster() {
		try {
			System.out.println("Aguardando slaves...");

			aceitador = new ControladorConexoes(this, port);
			aceitador.start();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public boolean isFind() {
		return finish;
	}

	public void setFind(boolean b) {
		finish = b;
	}

	public StringBE getNextString() {
		return sc.getString();
	}

	public void addNotCompleteString(StringBE s) {
		sc.addNotCompleteString(s);
	}

	public String getMD5String() {
		return MD5String;
	}

	public void setNoMD5(String NoMD5) {
		System.out.println("String encontrada " + NoMD5);
		try {
			new Socket("localhost", port);
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.originalString = NoMD5;
	}
}
