//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package master;

public class StringGen {
	private String chars = "abcdefghijklmnopqrstuvwyxzABCDEFGHIJKLMNOPQRSTUVWYXZ";
	private int numChars = 1;
	private char lastChar = '\n';
	private int charsSize;

	public synchronized StringBE getStrings() {
		charsSize = chars.length();
		return genString();
	}

	private StringBE genString() {

		char[] c = new char[numChars];
		char firstChar;

		if (lastChar == '\n') {
			firstChar = chars.charAt(0);
		} else {
			firstChar = chars.charAt(chars.indexOf(lastChar));
		}
		int pieceSize = (int) (charsSize / (numChars * numChars));
		for (int x = 0; x < numChars; x++) {
			c[x] = firstChar;
		}

		char[] f = new char[numChars];
		int charPos = (chars.indexOf(firstChar) - 1 + pieceSize);
		if (charPos >= charsSize) {
			charPos = charsSize - 1;
		}
		char fChar = chars.charAt(charPos);
		for (int x = 0; x < numChars; x++) {
			f[x] = fChar;
		}
		if (fChar == chars.charAt(charsSize - 1)) {
			lastChar = '\n';
			numChars = numChars + 1;
		} else {
			lastChar = fChar;
		}

		return new StringBE(new String(c), new String(f));
	}

}