//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package master.thread;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;

import master.Master;
import master.StringBE;
import utils.ResponseAnalyzer;

public class SlaveSockThread {
	private BufferedReader is;
	private DataOutputStream os;
	private Master m;
	private Socket mySocket;
	private SlaveSockThreadReceiver sl;
	private SlaveSockThreadEnd sle;
	private StringBE strrunning;
	private long timeLastMessage = System.currentTimeMillis();
	String line;

	public SlaveSockThread(Master master, Socket clientSocket) {
		m = master;
		mySocket = clientSocket;
		try {
			is = new BufferedReader(new InputStreamReader(
					mySocket.getInputStream()));
			os = new DataOutputStream(mySocket.getOutputStream());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		sl = new SlaveSockThreadReceiver(m, this);
		sle = new SlaveSockThreadEnd(m, this);

		sl.start();
		sle.start();

		send(ResponseAnalyzer.getAnswer(m, this,
				"<infos><func>setup</func></infos>"));
	}

	public void send(String m) {
		try {
			os.writeBytes(m);
		} catch (IOException e1) {
			timeLastMessage = 0;
		}
	}

	public BufferedReader getBufferReader() {
		return is;
	}

	public boolean getIsClosed() {
		if ((System.currentTimeMillis() - timeLastMessage) > 500000)
			return true;
		return false;
	}

	public void updateStrRunning(StringBE be) {
		strrunning = be;
	}

	public void updateBegin(String b) {
		strrunning.setBegin(b);
	}

	public void messageReceived() {
		timeLastMessage = System.currentTimeMillis();
	}
	
	public StringBE getStringRunning() { 
		return strrunning;
	}
}
