//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package slave;

import utils.MD5;

public class Searcher extends Thread {
	private Slave slave;
	private String chars = "abcdefghijklmnopqrstuvwyxzABCDEFGHIJKLMNOPQRSTUVWYXZ|";
	private String strNow;
	private char[] next;
	private String lastString;
	
	public Searcher(Slave sl) {
		slave = sl;
	}

	public void run() {
		while (slave.getBegin()==null)
			sleepALittle();
		
		next = slave.getBegin().toCharArray();
		strNow = slave.getBegin();
		MD5 objectMd5 = MD5.getInstance();
		while (!slave.getFinish()) {
			String sNext = getNext();
			String s = objectMd5.getEncoded(sNext);
			if (s.equals(slave.getMD5Str())) {
				slave.setFinish(true);
				slave.send("<infos><func>find</func><original>" + sNext + "</original></infos>");
			} else { 
				if (sNext.equals(slave.getEnd())) {
					String oldStringBegin = slave.getBegin();
					slave.send("<infos><func>more</func></infos>");
					if(slave.getBegin() == oldStringBegin) { 
						sleepALittle();
						while (slave.getBegin() == oldStringBegin) 
							sleepALittle();
						strNow = slave.getBegin();
					}
				}
			}
		}
		System.out.println("Searcher morreu");
	}

	public void sleepALittle() {
		try {
			sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public String getNext() {
		for (int i = next.length - 1; i >= 0; i--) {
			int pos = chars.indexOf(next[i]) + 1;
			next[i] = chars.charAt(pos);
			if (next[i] == '|') {
				next[i] = chars.charAt(0);
				if (i == 0) {
					next = new char[next.length + 1];
					for (int j = 0; j < next.length; j++) {
						next[j] = chars.charAt(0);
					}
				}
			} else {
				break;
			}
		}
		lastString = String.valueOf(next);
		return String.valueOf(lastString);
	}
	
	public String getLast() {
		return lastString;
	}
}
