//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package slave;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import utils.Responser;

public class Slave extends Responser {
	private String md5String;
	private boolean finish;
	private String begin = null;
	private String end = null;
	private Socket connection = null;
	private DataOutputStream output; 
	private Searcher s;
	
	public Slave(String ip, int port) {
		try {
			connection = new Socket(ip, port);
			ListenerSlave ov = new ListenerSlave(connection, this);
			ov.start();
			output = new DataOutputStream(connection.getOutputStream());
			
			s = new Searcher(this);
			s.start();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	public String getLastStringTested() { 
		return s.getLast();
	}
	public boolean getFinish() {
		return finish;
	}

	public void setFinish(boolean b) {
		this.finish = b;
	}

	public String getBegin() {
		return begin;
	}

	public void setBegin(String be) {
		begin = be;
	}

	public String getEnd() {
		return end;
	}

	public void setEnd(String en) {
		end = en;
	}

	public void setMD5Str(String m) {
		this.md5String = m;
	}

	public String getMD5Str() {
		return md5String;
	}

	public void send(String string) {
		System.out.println("Enviando mensagem " + string);
		try {
			output.writeBytes(string + "\n");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
