//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com] (stop since 0.1)

package utils;

import master.Master;
import master.StringBE;
import master.thread.SlaveSockThread;

import org.w3c.dom.CharacterData;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import slave.Slave;

public class ResponseAnalyzer {
	public static String getAnswer(Slave slave, String s) {
		NodeList n = XMLParse.getNodes(s);
		Element element = (Element) n.item(0);
		String function = getOther(element, "func").toLowerCase();
		if (function.equals("listbe")) {
			strBE(element, slave);
			return "";

		} else if (function.equals("config")) {
			String encodeStr = getOther(element, "codeStr");
			strBE(element, slave);
			slave.setMD5Str(encodeStr);
			return "";

		} else if (function.equals("die")) {
			slave.setFinish(true);
			return null;

		} else if (function.equals("ping")) {
			slave.send("<infos><func>pong</func><strnow>"
					+ slave.getLastStringTested() + "</strnow></infos>");
		}
		return "";
	}

	public static String getAnswer(Master master, SlaveSockThread slt, String str) {
		NodeList n = XMLParse.getNodes(str);
		Element element = (Element) n.item(0);
		String function = getOther(element, "func").toLowerCase();
		if (function.equals("find")) {
			master.setFind(true);
			master.setNoMD5(getOther(element, "original"));
			return null;
		} else if (function.equals("more")) {
			StringBE s = master.getNextString();
			slt.updateStrRunning(s);
			return createString(master, s);

		} else if (function.equals("setup")) {
			StringBE s = master.getNextString();
			slt.updateStrRunning(s);
			return createConfig(master, s);

		} else if (function.equals("pong")) {
			String beg = getOther(element, "strnow");
			slt.updateBegin(beg);
			return null;
		}
		return "";
	}

	private static void strBE(Element element, Slave slave) {
		String begin = getOther(element, "begin");
		String end = getOther(element, "end");
		slave.setBegin(begin);
		slave.setEnd(end);
	}

	private static String getOther(Element element, String name) {
		NodeList n = element.getElementsByTagName(name);
		String nstr = getCharacterDataFromElement((Element) n.item(0));
		return nstr;
	}

	private static String createConfig(Master m, StringBE s) {
		return "<infos><func>config</func><codeStr>" + m.getMD5String()
				+ "</codeStr><begin>" + s.getBegin() + "</begin><end>"
				+ s.getEnd() + "</end></infos>\n";
	}

	private static String createString(Master m, StringBE s) {
		return "<infos><func>LISTBE</func><begin>" + s.getBegin()
				+ "</begin><end>" + s.getEnd() + "</end></infos>\n";
	}

	public static String getCharacterDataFromElement(Element e) {
		Node child = e.getFirstChild();
		if (child instanceof CharacterData) {
			CharacterData cd = (CharacterData) child;
			return cd.getData();
		}
		return "?";
	}

}